/*
 * Script.h
 *
 *  Created on: Sep 19, 2012
 *      Author: tony
 */
#include <string>
#include <stdio.h>
#include <angelscript.h>
#include <vector>
#include <map>

extern int value;

void MessageCallback(const asSMessageInfo *msg, void *param);

using namespace std;
typedef std::map<std::string, asIScriptFunction *> METHODS;


#ifndef SCRIPT_H_
#define SCRIPT_H_

class Script {
public:
	Script();
	virtual ~Script();

	void RegisterGlobalVariable(string declaration, void * variable);
	//void AddFloatVariable(string varName, float &variable);
	int ConfigureEngine(string scriptText);
	void Release();
	void Run(int Number);
	void Run(char* Name);
	int IsValid();
private:

	int errors;
	int CheckFunctions();
	void RunFunction(asIScriptFunction  *fID);
	std::string LoadScript(std::string fileName);
	int CompileScript(std::string fileName);
	int r;
	int funcId;
	int funcId2;
	asIScriptEngine *engine;
	asIScriptContext *ctx;
	METHODS methods;
};


#endif /* SCRIPT_H_ */
