
#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <multipartpost.h>
#include <dhcpclient.h>
#include <taskmon.h>

#include <angelscript.h>
#include <HiResTimer.h>
#include <string>
#include <Script.h>
#include <ucos.h>

extern "C"
{
   void UserMain( void *pd );
}

const char *AppName = "AngelScript with JQuery based IDE";
double TotalTime = 0;
Script script;

//===== Implement critical section with OSCritEnter() & OSCritLeave() =====
OS_CRIT cs; // The critical section identifer


////////////////////////////////////////////////////////////////
//Global Variables that will be registered in the script engine
int value = 1000;
////////////////////////////////////////////////////////////////



// Declare our function from our form post code.
void RegisterPost();


void UserMain( void *pd )
{
   InitializeStack();

   if ( EthernetIP == 0 )
   {
      iprintf( "Trying DHCP\r\n" );
      GetDHCPAddress();
      iprintf( "DHCP assigned the IP address of :" );
      ShowIP( EthernetIP );
      iprintf( "\r\n" );
   }
   else
   {
      iprintf( "Static IP address set to :" );
      ShowIP( EthernetIP );
      iprintf( "\r\n" );
   }

   //Initialize the critical section to protect the script
   OSCritInit( &cs );

   //Registration of the global variable "value" in the script engine
   script.RegisterGlobalVariable("int value",(void*) &value);

   OSChangePrio( MAIN_PRIO );
   EnableAutoUpdate();
   StartHTTP();
   EnableTaskMonitor();

   // Enable multi part forms posting with a 500K max data block size
   if ( !EnableMultiPartForms( 500000 ) )
   {
      iprintf( "EnableMultiPartForms() initialization failed\r\n" );
   }
   RegisterPost();

   while ( 1 )
   {
     // OSTimeDly( TICKS_PER_SECOND );
      OSTimeDly( 1 );

        //Lock the critical section and run the script
	   	OSCritEnter( &cs, 0 );
	   	script.Run("One_Hz");
		OSCritLeave( &cs );

      //iprintf("value = %d\n", value);

   }
}
